MicroGP4
========

[![License: Apache 2.0](https://img.shields.io/badge/license-apache--2.0-green.svg)](https://opensource.org/licenses/Apache-2.0) 
[![Status: Actrive](https://img.shields.io/badge/status-active-brightgreen.svg)](https://github.com/squillero/microgp3)
![Language: Python](https://img.shields.io/badge/language-python-blue.svg)
![Version: 4!1.0α](https://img.shields.io/badge/version-4!1.0α-orange.svg)
![Codename: kiwi](https://img.shields.io/badge/codename-kiwi-orange.svg)
[![Documentation Status](https://readthedocs.org/projects/microgp4/badge/?version=pre-alpha)](https://microgp4.readthedocs.io/en/pre-alpha/?badge=pre-alpha)
![](https://www.google-analytics.com/collect?v=1&t=pageview&tid=UA-28094298-6&cid=4f34399f-f437-4f67-9390-61c649f9b8b2&dp=1)

MicroGP (µGP, `ugp`)  is an [evolutionary tool](https://squillero.github.io/microgp4/evolution.html) created around 2001. Over the years it has been exploited as a coverage-driven [fuzzer](https://en.wikipedia.org/wiki/Fuzzing), as a general-purpose [optimizer](https://en.wikipedia.org/wiki/Engineering_optimization), and as a framework for prototyping and testing new ideas. [Some hundreds documents](https://scholar.google.com/scholar?q=%28+MicroGP+OR+%C2%B5GP+OR+ugp3+OR+ugp2+%29+AND+%28+Squillero+OR+Tonda+OR+Sanchez+OR+Schillaci+%29) discussing it and possible application can be found in the scientific literature. [**[read more]**](https://microgp4.readthedocs.io/en/pre-alpha/summary.html)

#### :warning: MicroGP4 v1.0 is currently in [pre-alpha](https://en.wikipedia.org/wiki/Software_release_life_cycle#Pre-alpha) and under active development

> This repo is only useful if you want to hack the code (see: [CONTRIBUTING](CONTRIBUTING.md)).  
> For using MicroGP4 [read the instructions](https://microgp4.readthedocs.io/).  

### Notes

* The default branch is always the more stable
* Do not clone experimental branches `exp/*` unless you know what you are doing
* Follow the [style guide](https://github.com/squillero/style/blob/master/python.md)
* It may be wise to contact Alberto or Giovanni

### Documentation and Previous Versions

* The documentation for [MicroGP4](https://squillero.github.io/microgp4/) is on https://microgp4.readthedocs.io/
* The documentation for [MicroGP3](http://ugp3.sourceforge.net/) (v3.1 *"Bluebell"*), together with the old design rationale, can be found in the book *Evolutionary Optimization: the µGP toolkit*, Springer Science & Business Media (2011), [10.1007/978-0-387-09426-7](https://www.doi.org/10.1007/978-0-387-09426-7)
* [MicroGP2](https://github.com/squillero/microgp2) is described in the paper "MicroGP — An Evolutionary Assembly Program Generator", *Genetic Programming and Evolvable Machines*,  vol. 6, 247–263 (2005), [10.1007/s10710-005-2985-x](http://dx.doi.org/10.1007/s10710-005-2985-x)
* An evolutionary tool able to generate realistic assembly programs (MicroGP1) has been presented in the paper "Efficient machine-code test-program induction", *Proceedings of the Congress on Evolutionary Computation* (2002), [10.1109/CEC.2002.1004462](http://dx.doi.org/10.1109/CEC.2002.1004462)

### Contacts

* [Alberto](https://github.com/albertotonda/)  [:email:](mailto:alberto.tonda@inra.fr) [:house:](https://www.researchgate.net/profile/Alberto_Tonda)
* [Giovanni](https://github.com/squillero) [:email:](mailto:squillero@polito.it) [:house:](https://staff.polito.it/giovanni.squillero/)

### Licence
Copyright 2020-2021 Giovanni Squillero and Alberto Tonda  
MicroGP4 is [free and open-source software](https://en.wikipedia.org/wiki/Free_and_open-source_software), and it is distributed under the permissive [Apache License 2.0](https://www.tldrlegal.com/l/apache2).
